<?php
/*
Simple:Press
Topic Watches plugin ahah routine for management functions
$LastChangedDate: 2013-08-23 12:55:44 -0700 (Fri, 23 Aug 2013) $
$Rev: 10569 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

sp_forum_api_support();

include_once(WLIBDIR.'sp-watches-database.php');
if (!sp_get_auth('watch')) {
	if (!is_user_logged_in()) {
		_e('Access denied - are you logged in?', 'sp-watches');
	} else {
		_e('Access denied - you do not have permission', 'sp-watches');
	}
	die();
}

global $spThisUser, $spListView, $spGlobals;

$action = (isset($_GET['action'])) ? $_GET['action'] : '';

# Update the Watched Topic Count
if (isset($_GET['target']) && $_GET['target'] == 'watches') {
	if (sp_get_auth('watch')) {
		$watchCount = 0;
		$list = $spThisUser->watches;
		if (!empty($list)) {
			foreach ($list as $topicid) {
				if (sp_is_in_users_newposts($topicid)) $watchCount++;
			}
		}
        $watchClass = ($watchCount > 0) ? 'spWatchCountUnread' : 'spWatchCountRead';
		echo "<span class='$watchClass'>$watchCount</span>";
	}
	die();
}

if ($action == 'remove-watch') {
    $topic = sp_esc_int($_GET['topic']);
    $user = sp_esc_int($_GET['user']);
    if ($user == $spThisUser->ID) sp_watches_remove_watch($topic, $user);
    die();
}

if ($action == 'add-watch') {
    global $spThisUser;
	if (!$spThisUser->admin && !$spThisUser->moderator) die();

    $forumid = sp_esc_int($_GET['fid']);
    $topicid = sp_esc_int($_GET['tid']);
    if (empty($forumid) || empty($topicid)) die();

	$thisforum = spdb_table(SFFORUMS, "forum_id=$forumid", 'row');
?>
	<div id="spMainContainer" class="spForumToolsPopup">
		<div class="spForumToolsHeader">
			<div class="spForumToolsHeaderTitle"><?php echo __('Select user(s) you want to watch this topic', 'sp-watches').':'; ?></div>
		</div>
		<form action="<?php echo sp_build_url($thisforum->forum_slug, '', 1, 0); ?>" method="post" name="watchtopicform">
			<input type="hidden" name="currenttopicid" value="<?php echo $topicid; ?>" />
			<div class="spCenter">
				<br /><?php echo sp_render_admin_mod_select($forumid, __('Select user(s)', 'sp-watches'));	?><br /><br />
				<input type="submit" class="spSubmit" name="maketopicwatch" value="<?php echo esc_attr(__('Add watch to user(s)', 'sp-watches')) ?>" />
				<input type="button" class="spSubmit" name="cancel" value="<?php echo esc_attr(__('Cancel', 'sp-watches')) ?>" onclick="jQuery('#dialog').dialog('close');" />
			</div>
		</form>
	</div>
<?php

    die();
}

if ($action == 'watch') {
    global $spMobile;
    if (!$spMobile) {
?>
    <script type="text/javascript">
    jQuery(document).ready(function() {
    	jQuery(function(jQuery){vtip();})
    });
</script>
<?php
    }
    add_action('sph_ListViewBodyEnd', 'sp_watches_list_button');

	echo '<div id="spMainContainer">';
	if (!empty($spThisUser->watches)) {
    	echo '<div class="spStopWatchingAll">';
    	echo '<form action="'.sp_url().'" method="get" name="endallwatches">';
    	echo '<input type="hidden" class="sfhiddeninput" name="userid" id="userid" value="'.$spThisUser->ID.'" />';
    	echo '<input type="submit" class="spSubmit" name="endallwatches" value="'.esc_attr(__('Remove All Watches', 'sp-watches')).'" />';
    	echo '</form>';
    	echo '</div>';

        $first = sp_esc_int($_GET['first']);
        $spListView = new spTopicList($spThisUser->watches, 0, true, '', $first);

        sp_load_template('spListView.php');
    } else {
		echo '<div class="spMessage">';
		echo '<p>'.__('You are not currently watching any topics', 'sp-watches').'</p>';
		echo '</div>';
    }

    echo '</div>';
    die();
}

if ($action == 'update-topic-watches') {
    $userid = sp_esc_int($_GET['user']);
	if (empty($userid)) die();

    global $spProfileUser;
	sp_SetupUserProfileData($userid);
    if ($spProfileUser->watches) {
        $found = false;
    	foreach ($spProfileUser->watches as $watch) {
        	$topic = spdb_table(SFTOPICS, "topic_id=$watch", 'row');
            if ($topic) {
                $found = true;
            	echo '<div class="spColumnSection">';
                echo '<label for="sf-topic-'.$topic->topic_id.'">';
                echo $topic->topic_name.' (<a target="_blank" href="'.sp_permalink_from_postid($topic->post_id).'">'.__('view topic', 'sp-watches').')</a> ('.$topic->post_count.' '.__('posts', 'sp-watches').')<br />';
                echo '</label><input type="checkbox" name="topic['.$topic->topic_id.']" id="sf-topic-'.$topic->topic_id.'" />';
            	echo '</div>';
            }
    	}
        if (!$found) {
        	echo '</form>';
            echo '<p>'.__('You are not currently watching any topics', 'sp-watches').'</p><br />';
            echo "</div>\n";
        }
    } else {
    	echo '<p>'.__('You are not currently watching any topics', 'sp-watches').'</p><br />';
    }
?>
	<script type="text/javascript">
	jQuery(document).ready(function() {
        spjSetProfileDataHeight();
        jQuery("input[type=checkbox], input[type=radio]").prettyCheckboxes();
	})
	</script>
<?php

	die();
}

function sp_render_admin_mod_select($forumid, $default) {
    $out = '<select multiple="multiple" class="spSelect" name="spWatchesUsers[]">';
    $out.= '<option>'.$default.'</option>';
   	$users = spdb_select('set', 'SELECT user_id, display_name FROM '.SFMEMBERS.' WHERE admin=1 OR moderator=1 ORDER BY admin DESC, moderator DESC');
    if ($users) {
        foreach ($users as $user) {
            if (sp_can_view($forumid, 'topic-title', $user->user_id)) {
                $out.= "<option value='$user->user_id'>$user->display_name</option>";
            }
        }
    }
    $out.='</select>';
    echo $out;
}

function sp_watches_list_button() {
    global $spThisUser, $spThisListTopic;

    $site = SFHOMEURL.'index.php?sp_ahah=watches-manage&amp;sfnonce='.wp_create_nonce('forum-ahah').'&amp;action=remove-watch&amp;topic='.$spThisListTopic->topic_id.'&amp;user='.$spThisUser->ID;
	echo '<a rel="nofollow" class="spButton spRight spWatchEndButton" title="'.__('Stop Watching Topic', 'sp-watches').'" href="javascript:void(null)" onclick="jQuery(\'#listtopic'.$spThisListTopic->topic_id.'\').fadeOut(2000, function(){jQuery(\'#listtopic'.$spThisListTopic->topic_id.'\').load(\''.$site.'\')});">';
	echo '<img class="spIcon" src="'.sp_find_icon(WIMAGES, 'sp_WatchesStopWatch.png').'" alt="" />'.__('Stop Watching', 'sp-watches');
	echo '</a>';
}

die();

?>