<?php
/*
Simple:Press
Topic Watches plugin ahah routine for users management functions
$LastChangedDate: 2013-03-02 10:25:01 -0700 (Sat, 02 Mar 2013) $
$Rev: 9945 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

spa_admin_ahah_support();

include_once(WLIBDIR.'sp-watches-database.php');
include_once(WLIBDIR.'sp-watches-components.php');

# Check Whether User Can Manage Users
if (!sp_current_user_can('SPF Manage Users')) {
	_e('Access denied - you do not have permission', 'sp-watches');
	die();
}

$action = $_GET['action'];

if ($action == 'topiclist') {
	$error = '';
	if (isset($_GET['groups']) && sp_esc_str($_GET['groups']) == 'error') $error = 'Group';
	if (isset($_GET['forums']) && sp_esc_str($_GET['forums']) == 'error') $error = 'Forums';
	if ($error) {
		echo sprintf(__('You elected to filter by %1$s but selected no %2$s items', 'sp-watches'), $error, $error);
		die();
	}

	sp_watches_render_topic_watches();
	die();
}

if ($action == 'del_watches') {
	$tid = sp_esc_int($_GET['id']);
	sp_watches_remove_topic_watches($tid);
}

if ($action == 'display-groups') {
	echo '<select style="width:200px" multiple size="10" class="sfacontrol" id="grouplist" name="watchesgroups[]">';
	$groups = spdb_table(SFGROUPS, '', '', 'group_seq');
	if ($groups) {
		foreach ($groups as $group) {
			echo '<option value="'.$group->group_id.'">'.sp_filter_title_display($group->group_name).'</option>';
		}
	}
	echo '</select>';
	echo '<br />';
	echo '<input type="button" class="button button-highlighted" value="'.__('Close', 'sp-watches').'" onclick="spjToggleLayer(\'select-group\');">';
}

if ($action == 'display-forums') {
	echo '<select style="width:200px" multiple size="10" class="sfacontrol" id="forumlist" name="watchesforums[]">';
	$forums = spa_get_forums_all();
	if ($forums) {
		$thisgroup = 0;
		foreach ($forums as $forum) {
			if ($thisgroup != $forum->group_id) {
				if ($thisgroup != 0) {
					echo '</optgroup>';
				}
				echo '<optgroup label="'.sp_filter_title_display($forum->group_name).'">';
				$thisgroup = $forum->group_id;
			}
			echo '<option value="'.$forum->forum_id.'">'.sp_filter_title_display($forum->forum_name).'</option>';
		}
	}
	echo '</optgroup></select>';
	echo '<br />';
	echo '<input type="button" class="button button-highlighted" value="'.__('Close', 'sp-watches').'" onclick="spjToggleLayer(\'select-forum\');">';
}

die();

function sp_watches_render_topic_watches() {
    $filter = sp_esc_str($_GET['filter']);
    if (isset($_GET['page']))  {
    	$curpage = sp_esc_int($_GET['page']);
   	} else {
   		$curpage = 1;
   	}
    if (isset($_GET['swsearch'])) {
    	$search = sp_esc_str($_GET['swsearch']);
   	} else {
   		$search = '';
   	}
    if (isset($_GET['groups'])) {
    	$groups = explode('-', sp_esc_str($_GET['groups']));
    } else {
		$groups[0] = -1;
	}
    if (isset($_GET['forums'])) {
    	$forums = explode('-', sp_esc_str($_GET['forums']));
    } else {
		$forums[0] = -1;
	}
	$data = sp_watches_get_topic_watches($filter, $groups, $forums, $curpage, $search);
	$records = $data['data'];

	# paging
	$totalpages = ceil($data['count'] / 20);
	echo '<div class="sfform-panel">';
	echo '<div class="sfform-panel-head">';
	echo '<span class="sftitlebar">'.__('Manage Users - Watches by Topic', 'sp-watches').'</span>';
	echo '</div>';
	echo '<table width="100%" cellspacing="0" cellpadding="0"><tr><td>';
	echo '<fieldset class="sffieldset"><legend><strong>'.__('Topic Watches', 'sp-watches').'</strong></legend>';
	echo '<div class="tablenav">';
	echo '<div class="tablenav-pages">';
	echo '<strong>'.__('Page:', 'sp-watches').'</strong>  ';
	echo sp_watches_topics_pn_next($curpage, $totalpages, 3);
	echo '<span class="page-numbers current">'.$curpage.'</span>';
	echo sp_watches_topics_pn_previous($curpage, $totalpages, 3);
	echo '</div>';

	echo '<div>';
    $site = SFHOMEURL.'index.php?sp_ahah=watches-topics&sfnonce='.wp_create_nonce('forum-ahah').'&action=topiclist&page=1';
	$gif = SFCOMMONIMAGES.'working.gif';
	echo '<form action="'.SFADMINUSER.'" method="post" name="sptopicwatches" id="sptopicwatches" onsubmit="return spjShowWatchesList(this, \''.$site.'\', \''.$gif.'\');" >';
?>
	<input type="text" class="sfacontrol" id="post-search-input" name="swsearch" value="<?php echo esc_attr($search); ?>" />
	<input type="button" class="button-primary" onclick="spjShowWatchesList('sptopicwatches', '<?php echo $site; ?>', '<?php echo $gif; ?>');" value="<?php esc_attr_e(__('Search', 'sp-watches')); ?>" />
	</form>
	</div>
<?php
	echo '</div>';

	# show data
	echo '<table class="sfsubtable" cellpadding="0" cellspacing="0">';
	if ($records) {
		echo '<tr>';
		echo '<th width="15%" align="left"><small>'.__('Group', 'sp-watches').'</small></th>';
		echo '<th width="20%" align="left"><small>'.__('Forum', 'sp-watches').'</small></th>';
		echo '<th width="20%" align="left"><small>'.__('Topic', 'sp-watches').'</small></th>';
		echo '<th><small>'.__('Watches', 'sp-watches').'</small></th>';
		echo '<th align="right" width="50" style="padding-right:20px"><small>'.__('Manage', 'sp-watches').'</small></th>';
		echo '</tr>';
		foreach ($records as $index => $record) {
			echo '<tr>';
			echo '<td colspan="5" style="border-bottom:0px;padding:0;">';
			echo '<div id="topic-watches'.$index.'">';
			echo '<table width="100%" cellspacing="0">';
			echo '<tr>';
			echo '<td width="15%">'.sp_filter_title_display($record->group_name).'</td>';
			echo '<td width="20%">'.sp_filter_title_display($record->forum_name).'</td>';
			$url = sp_build_url($record->forum_slug, $record->topic_slug, 1, 0);
			echo '<td width="20%"><a href="'.$url.'">'.sp_filter_title_display($record->topic_name).'</a></td>';
			echo '<td>';
			if ($record->topic_watches) {
				$first = true;
				$list = unserialize($record->topic_watches);
				for ($x=0; $x<count($list); $x++) {
					if ($first) {
						echo sp_filter_name_display(sp_get_member_item($list[$x], 'display_name'));
						$first = false;
					} else {
						echo ', '.sp_filter_name_display(sp_get_member_item($list[$x], 'display_name'));
					}
				}
			}
			echo '</td>';
			$gif = SFCOMMONIMAGES.'working.gif';
			echo '<td width="50" align="center">';
			if ($record->topic_watches) {
                $site = SFHOMEURL.'index.php?sp_ahah=watches-topics&sfnonce='.wp_create_nonce('forum-ahah').'&action=del_watches&id='.$record->topic_id;
				?>
				<img onclick="spjDelRow('<?php echo $site; ?>', 'topic-watches<?php echo $index; ?>');" src="<?php echo SFCOMMONIMAGES; ?>delete.png" title="<?php esc_attr_e(__('Delete Watches', 'sp-watches')); ?>" />&nbsp;
				<?php
			}
			echo '</td>';
			echo '</tr>';
			echo '</table>';
			echo '</div>';
			echo '</td>';
			echo '</tr>';
		}
	} else {
		echo '<tr>';
		echo '<td>';
		_e('No watches found!', 'sp-watches');
		echo '</td>';
		echo '</tr>';
	}
	echo '</table>';
	echo '</fieldset></td></tr></table>';
	echo '</div>';
}
?>