<?php
/*
Simple:Press
Topic Watches Plugin Support Routines
$LastChangedDate: 2013-08-23 12:55:44 -0700 (Fri, 23 Aug 2013) $
$Rev: 10569 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_watches_do_profile_update($message, $thisUser, $thisForm) {
    if (isset($_POST['formsubmitall'])) {
        sp_watches_remove_user_watches($thisUser);

        $message['type'] = 'success';
        $message['text'] = __('All topic watches stopped', 'sp-watches');
        return $message;
    } else if (empty($_POST['topic'])) {
        $message['type'] = 'error';
        $message['text'] = __('No watched topics selected', 'sp-watches');
        return $message;
    } else {
        foreach ($_POST['topic'] as $topic_id => $topic) {
            sp_watches_remove_watch($topic_id, $thisUser, false);
        }
        $message['type'] = 'success';
        $message['text'] = __('Watches updated', 'sp-watches');
        return $message;
    }
    return $message;
}

function sp_watches_do_reset_profile_tabs() {
   	sp_profile_add_tab(__('Watches', 'sp-watches'));
	sp_profile_add_menu(__('Watches', 'sp-watches'), __('Manage Watches', 'sp-watches'), WFORMSDIR.'sp-watches-manage-form.php');
}

function sp_watches_do_post_footer($out, $spThisTopic, $a) {
    global $spThisTopic;

    if (!empty($spThisTopic->topic_watches)) {
        $out.= '<div class="spEditorSection">';
		$icon = sp_find_icon(WIMAGES, 'sp_WatchesForumStatus.png');
		$out.= "<p class='spWatchesNotice'><img class='vtip' src='$icon' alt='' /> ".__('This topic has watches', 'sp-watches').'</p>';
        $out.= '</div>';
    }
    return $out;
}

function sp_watches_forum_tool($out, $forum, $topic) {
    global $spThisUser;
	if ($spThisUser->admin || $spThisUser->moderator) {
		$out.= '<div class="spForumToolsWatches">';
		$out.= '<img class="spIcon" src="'.sp_find_icon(WIMAGES, 'sp_ToolsWatches.png').'" alt="" title="" />';
        $title = esc_js(__('Add watch for user', 'sp-watches'));
    	$site = SFHOMEURL.'index.php?sp_ahah=watches-manage&amp;sfnonce='.wp_create_nonce('forum-ahah').'&amp;action=add-watch&amp;tid='.$topic['topic_id'].'&amp;fid='.$forum['forum_id'];
		$out.= '<a rel="nofollow" href="javascript:void(null)" onclick="spjDialogAjax(this, \''.$site.'\', \''.$title.'\', 400, 0, \'center\');">'.$title.'</a>';
		$out.= '</div>';
	}
    return $out;
}

function sp_watches_do_quick_reply($newpost) {
    global $spThisUser;
	$watchvar = 'watchtopic'.$newpost['topicid'];
	if (isset($_GET[$watchvar]) && $_GET[$watchvar] == '1') {
    	sp_watches_save_watch($newpost['topicid'], $spThisUser->ID, false);
    }
}

function sp_watches_do_admin_bar($newtopic, $topic, $post) {
	echo '&nbsp;<label for="sfwatchtopic'.$topic['topic_id'].'"><small>'.__('Watch this Topic', 'sp-watches').'</small>&nbsp;</label>';
	echo '<input type="checkbox" id="sfwatchtopic'.$topic['topic_id'].'" class="spWatchTopic" name="watchtopic'.$topic['topic_id'].'" />';
}

function sp_watches_do_deactivate() {
	# remove our profile tab/meuns
    sp_profile_delete_tab(__('Watches', 'sp-watches'));

    # remove our auto update stuff
    $up = sp_get_sfmeta('autoupdate', 'watches');
    if ($up) sp_delete_sfmeta($up[0]['meta_id']);

    sp_deactivate_auth('watch');
}

function sp_watches_do_header() {
	$css = sp_find_css(WCSS, 'sp-watches.css');
    sp_plugin_enqueue_style('sp-watches', $css);
}

function sp_watches_do_forum_status($content) {
	global $spThisTopic, $spDevice;
	$out = '';
	if (!empty($spThisTopic->topic_watches)) {
		$p = ($spDevice=='mobile') && (defined('SP_MOBILE_THEME') && SP_MOBILE_THEME) ? WIMAGESMOB : WIMAGES;
		$icon = sp_find_icon($p, 'sp_WatchesForumStatus.png');
		$out.= "<img class='spIcon spIconNoAction vtip' src='$icon' title='".esc_attr(__('This topic has watches', 'sp-watches'))."' alt='' />";
	}
	return $content.$out;
}

function sp_watches_do_post_form_options($display, $thisTopic) {
	global $spThisUser;

	$out = '';
	if (sp_get_auth('watch', $thisTopic->forum_id)) {
		$watching = sp_watches_is_watching($spThisUser->ID, $thisTopic->topic_id);
		if (!$watching) {
            $label = apply_filters('sph_watches_watch_label', __('Watch this topic', 'sp-watches'));
			$out.= '<label class="spLabel spCheckbox" for="sftopicwatch">'.$label.'</label>';
			$out.= '<input type="checkbox" class="spControl" name="topicwatch" id="sftopicwatch" /><br />';
		} else {
            $label = apply_filters('sph_watches_end_watch_label', __('Stop watching this topic', 'sp-watches'));
			$out.= '<label class="spLabel spCheckbox" for="sftopicwatchend">'.$label.'</label>';
			$out.= '<input type="checkbox" class="spControl" name="topicwatchend" id="sftopicwatchend" /><br />';
		}
	}

	return $display.$out;
}

function sp_watches_do_topic_form_options($display, $thisForum) {
	global $spThisUser;

	$out = '';
	if (sp_get_auth('watch', $thisForum->forum_id)) {
        $label = apply_filters('sph_watches_watch_label', __('Watch this topic', 'sp-watches'));
		$out.= '<label class="spLabel spCheckbox" for="sftopicwatch">'.$label.'</label>';
		$out.= '<input type="checkbox" class="spControl" name="topicwatch" id="sftopicwatch" /><br />';
	}

	return $display.$out;
}

function sp_watches_do_load_js($footer) {
	$sfauto = sp_get_option('sfauto');
	if ($sfauto['sfautoupdate']) sp_plugin_enqueue_script('sfwatchesupdate', WSCRIPT.'sp-watches-update.js', array('jquery'), false, $footer);
}

function sp_watches_do_post_create($msg, $newpost) {
    include_once(WLIBDIR.'sp-watches-database.php');

	# watching?
	if (sp_get_auth('watch', $newpost['forumid']) && !empty($newpost['topicwatch'])) {
		sp_watches_save_watch($newpost['topicid'], $newpost['userid'], true);
		$msg.= ' '.__('and Watching', 'sp-watches');
	}

	# stop watching?
	if (sp_get_auth('watch', $newpost['forumid']) && !empty($newpost['topicwatchend'])) {
		sp_watches_remove_watch($newpost['topicid'], $newpost['userid']);
		$msg.= ' '.__('and Ending Watch', 'sp-watches');
	}

	return $msg;
}

function sp_watches_do_topic_delete($posts) {
	$thisTopic = (is_object($posts)) ? $posts : $posts[0];
 	$watches = spdb_table(SFTOPICS, "topic_id=$thisTopic->topic_id", 'topic_watches');
	if ($watches) {
		$userlist = unserialize($watches);
		foreach ($userlist as $user) {
			$topiclist = sp_get_member_item($user, 'watches');
			if (!empty($topiclist)) {
				$newlist = '';
				foreach ($topiclist as $topic) {
					if ($topic != $topicid) $newlist[] = $topic;
				}
				sp_update_member_item($user, 'watches', $newlist);
			}
		}
	}
}

function sp_watches_do_process_actions() {
	global $spThisUser;

    include_once(WLIBDIR.'sp-watches-database.php');

    if (isset($_GET['watch']) || isset($_GET['endwatch'])) {
    	if (isset($_GET['watch'])) sp_watches_save_watch(sp_esc_int($_GET['topic']), $spThisUser->ID);
    	if (isset($_GET['endwatch'])) sp_watches_remove_watch(sp_esc_int($_GET['topic']), $spThisUser->ID);

    	if (isset($_GET['forumslug']) || isset($_GET['topicslug'])) {
    	    $page = (isset($_GET['page'])) ? sp_esc_int($_GET['page']) : '';
    		$returnURL = sp_build_url(sp_esc_str($_GET['forumslug']), sp_esc_str($_GET['topicslug']), $page, sp_esc_int($_GET['post']));
    		?>
    		<script type="text/javascript">window.location= "<?php echo $returnURL; ?>";</script>
    		<?php
    		exit();
    	}
    }

	if (isset($_GET['endallwatches'])) sp_watches_remove_user_watches(sp_esc_int($_GET['userid']));
    if (isset($_POST['maketopicwatch'])) sp_watches_add_watches(sp_esc_int($_POST['currenttopicid']), sp_esc_str($_POST['spWatchesUsers']));
}

function sp_watches_uninstall_option_links($actionlink, $plugin) {
	if ($plugin == 'watches/sp-watches-plugin.php') {
        $url = SFADMINPLUGINS.'&amp;action=uninstall&amp;plugin='.$plugin.'&amp;sfnonce='.wp_create_nonce('forum-adminform_plugins');
        $actionlink.= "&nbsp;&nbsp;<a href='$url' title='".__('Uninstall this plugin', 'sp-watches')."'>".__('Uninstall', 'sp-watches').'</a>';
    }
	return $actionlink;
}

function sp_watches_is_watching($userid, $topicid) {
	if (!$userid || !$topicid) return '';

	$list = sp_get_member_item($userid, 'watches');
	if (empty($list)) return false;

	$found = false;
	if (in_array($topicid, $list)) $found = true;
	return $found;
}

function sp_watches_topics_pn_next($cpage, $totalpages, $pnshow) {
    $start = ($cpage - $pnshow);
    if ($start < 1) $start = 1;
    $end = ($cpage - 1);
    $out = '';

    if ($start > 1) {
        $out.= sp_watches_topics_pn_url(1);
        $out.= '<span class="page-numbers dota">...</span>';
    }

    if ($end > 0) {
        for ($i = $start; $i <= $end; $i++) {
            $out.= sp_watches_topics_pn_url($i);
        }
    }

    return $out;
}

function sp_watches_topics_pn_previous($cpage, $totalpages, $pnshow) {
    $start = ($cpage + 1);
    $end = ($cpage + $pnshow);
    if ($end > $totalpages) $end = $totalpages;
    $out = '';

    if ($start <= $totalpages) {
        for ($i = $start; $i <= $end; $i++) {
            $out.= sp_watches_topics_pn_url($i);
        }
        if ($end < $totalpages) {
            $out.= '<span class="page-numbers dota">...</span>';
            $out.= sp_watches_topics_pn_url($totalpages);
        }
    }

    return $out;
}

function sp_watches_topics_pn_url($thispage) {
    $site = SFHOMEURL.'index.php?sp_ahah=watches-topics&sfnonce='.wp_create_nonce('forum-ahah').'&action=topiclist&page='.$thispage;
    $gif = SFCOMMONIMAGES.'working.gif';
    $out = '<a rel="nofollow" class="page-numbers" href="#" onclick="spjShowWatchesList(\'sptopicwatches\', \''.$site.'\', \''.$gif.'\');">'.$thispage.'</a>';
    return $out;
}

function sp_watches_render_user_watches($curpage=1, $search='') {
	$data = sp_watches_get_user_watches($curpage, $search);
	$records = $data['data'];

	# paging
	$totalpages = ceil($data['count'] / 20);
	echo '<div class="tablenav">';
	echo '<div class="tablenav-pages">';
	echo '<strong>'.__('Page:', 'sp-watches').'</strong>  ';
	echo sp_watches_users_pn_next($curpage, $totalpages, 3);
	echo '<span class="page-numbers current">'.$curpage.'</span>';
	echo sp_watches_users_pn_previous($curpage, $totalpages, 3);
	echo '</div>';

	echo '<div>';
    $site = SFHOMEURL.'index.php?sp_ahah=watches-users&sfnonce='.wp_create_nonce('forum-ahah').'&action=topiclist&page=1';
	$gif = SFCOMMONIMAGES.'working.gif';
	echo '<form action="'.SFADMINUSER.'" method="post" name="sptopicusers" id="sptopicusers" onsubmit="return spjShowWatchesList(this, \''.$site.'\', \''.$gif.'\');" >';
?>
	<input type="text" class="sfacontrol" id="post-search-input" name="swsearch" value="<?php echo esc_attr($search); ?>" />
	<input type="button" class="button-primary" onclick="spjShowWatchesList('watchesdisplayspot', '<?php echo $site; ?>', '<?php echo $gif; ?>');" value="<?php esc_attr_e(__('Search', 'sp-watches')); ?>" />
	</form>
	</div>
<?php
	echo '</div>';

	# show data
	echo '<table class="sfsubtable" cellpadding="0" cellspacing="0">';
	if ($records) {
		echo '<tr>';
		echo '<th width="10%" align="center"><small>'.__('User ID', 'sp-watches').'</small></th>';
		echo '<th width="20%" align="left"><small>'.__('Display Name', 'sp-watches').'</small></th>';
		echo '<th><small>'.__('Watches', 'sp-watches').'</small></th>';
		echo '<th align="right" width="50" style="padding-right:20px"><small>'.__('Manage', 'sp-watches').'</small></th>';
		echo '</tr>';
		foreach ($records as $index => $record) {
			echo '<tr>';
			echo '<td colspan="4" style="border-bottom:0px;padding:0;">';
			echo '<div id="user-watches'.$index.'">';
			echo '<table width="100%" cellspacing="0">';
			echo '<tr>';
			echo '<td width="10%" align="center">'.$record->user_id.'</td>';
			echo '<td width="20%">'.sp_filter_name_display($record->display_name).'</td>';
			echo '<td>';
			$topics = unserialize($record->watches);
			foreach ($topics as $topic) {
				$forum = spdb_select('row',
						'SELECT topic_id, topic_slug, topic_name, forum_slug
						 FROM '.SFTOPICS.'
						 JOIN '.SFFORUMS.' ON '.SFTOPICS.'.forum_id = '.SFFORUMS.'.forum_id
						 WHERE topic_id = '.$topic);
				$url = sp_build_url($forum->forum_slug, $forum->topic_slug, 1, 0);
				echo __('Topic ID', 'sp-watches').': '.$forum->topic_id.'&nbsp;&nbsp;&nbsp;'.__('Topic', 'sp-watches').': <a href="'.$url,'">'.sp_filter_title_display($forum->topic_name).'</a><br />';
			}
			echo '</td>';
			$gif = SFCOMMONIMAGES."working.gif";
			echo '<td width="50" align="center">';
            $site = SFHOMEURL.'index.php?sp_ahah=watches-users&sfnonce='.wp_create_nonce('forum-ahah').'&action=del_watches&id='.$record->user_id;
			?>
			<img onclick="spjDelRow('<?php echo $site; ?>', 'user-watches<?php echo $index; ?>');" src="<?php echo SFCOMMONIMAGES; ?>delete.png" title="<?php esc_attr_e(__('Delete Watches', 'sp-watches')); ?>" />&nbsp;
			<?php
			echo '</td>';
			echo '</tr>';
			echo '</table>';
			echo '</div>';
			echo '</td>';
			echo '</tr>';
		}
	} else {
		echo '<tr>';
		echo '<td>';
		_e('No watches found!', 'sp-watches');
		echo '</td>';
		echo '</tr>';
	}
	echo '</table>';
}

function sp_watches_users_pn_next($cpage, $totalpages, $pnshow) {
    $start = ($cpage - $pnshow);
    if ($start < 1) $start = 1;
    $end = ($cpage - 1);
    $out = '';

    if ($start > 1) {
        $out.= sp_watches_users_pn_url(1);
        $out.= '<span class="page-numbers dota">...</span>';
    }

    if ($end > 0) {
        for ($i = $start; $i <= $end; $i++) {
            $out.= sp_watches_users_pn_url($i);
        }
    }

    return $out;
}

function sp_watches_users_pn_previous($cpage, $totalpages, $pnshow) {
    $start = ($cpage + 1);
    $end = ($cpage + $pnshow);
    if ($end > $totalpages) $end = $totalpages;
    $out = '';

    if ($start <= $totalpages) {
        for ($i = $start; $i <= $end; $i++) {
            $out.= sp_watches_users_pn_url($i);
        }
        if ($end < $totalpages) {
            $out.= '<span class="page-numbers dota">...</span>';
            $out.= sp_watches_users_pn_url($totalpages);
        }
    }

    return $out;
}

function sp_watches_users_pn_url($thispage) {
    $site = SFHOMEURL.'index.php?sp_ahah=watches-users&sfnonce='.wp_create_nonce('forum-ahah').'&action=topiclist&page='.$thispage;
    $gif = SFCOMMONIMAGES.'working.gif';
    $out = '<a rel="nofollow" class="page-numbers" href="#" onclick="spjShowWatchesList(\'sptopicusers\', \''.$site.'\', \''.$gif.'\');">'.$thispage.'</a>';
    return $out;
}

?>