<?php
/*
Simple:Press
Watches plugin install/upgrade routine
$LastChangedDate: 2013-03-18 06:48:07 -0700 (Mon, 18 Mar 2013) $
$Rev: 10094 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_watches_do_install() {
	$watches = sp_get_option('watches');
	if (empty($watches)) {
        # need new columns
		spdb_query('ALTER TABLE '.SFTOPICS.' ADD (topic_watches longtext)');
		spdb_query('ALTER TABLE '.SFMEMBERS.' ADD (watches longtext)');

		$watches = array();
        $watches['dbversion'] = SPWATCHESDBVERSION;
		sp_add_option('watches', $watches);
    }

   	sp_profile_add_tab(__('Watches', 'sp-watches'));
	sp_profile_add_menu(__('Watches', 'sp-watches'), __('Manage Watches', 'sp-watches'), WFORMSDIR.'sp-watches-manage-form.php');

	# add in auto update stuff
    $autoup = array('spjwatchesupdate', SFHOMEURL.'index.php?sp_ahah=watches-manage&amp;target=watches');
    sp_add_sfmeta('autoupdate', 'watches', $autoup);

    # add a new permission into the auths table
	sp_add_auth('watch', __('Can watch topics within a forum', 'sp-watches'), 1, 1, 0, 0, 1);

    # activation so make our auth active
    sp_activate_auth('watch');

	# flush rewrite rules for pretty permalinks
	global $wp_rewrite;
	$wp_rewrite->flush_rules();
}

function sp_watches_do_reset_permissions() {
	sp_add_auth('watch', __('Can watch topics within a forum', 'sp-watches'), 1, 1, 0, 0, 1);
}
?>