<?php
/*
Simple:Press Plugin Title: Watches
Version: 1.3.1
Plugin URI: http://simple-press.com
Description: A Simple:Press plugin for allowing watching of topics
Author: Andy Staines & Steve Klasen
Author URI: http://simple-press.com
Simple:Press Versions: 5.2.3 and above
A plugin for Simple:Press to allow users to watch topics.
$LastChangedDate: 2013-08-23 12:55:44 -0700 (Fri, 23 Aug 2013) $
$Rev: 10569 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

# IMPORTANT DB VERSION
define('SPWATCHESDBVERSION', 2);

define('WDIR', 		SFPLUGINDIR.'watches/');
define('WADMINDIR', SFPLUGINDIR.'watches/admin/');
define('WLIBDIR', 	SFPLUGINDIR.'watches/library/');
define('WAHAHDIR', 	SFPLUGINDIR.'watches/ahah/');
define('WSCRIPT', 	SFPLUGINURL.'watches/resources/jscript/');
define('WCSS', 		SFPLUGINURL.'watches/resources/css/');
define('WTAGSDIR', 	SFPLUGINDIR.'watches/template-tags/');
define('WTEMPDIR', 	SFPLUGINDIR.'watches/template-files/');
define('WFORMSDIR', SFPLUGINDIR.'watches/forms/');
define('WIMAGES', 	SFPLUGINURL.'watches/resources/images/');
define('WIMAGESMOB',SFPLUGINURL.'watches/resources/images/mobile/');

add_action('sph_activate_watches/sp-watches-plugin.php',    	'sp_watches_install');
add_action('sph_deactivate_watches/sp-watches-plugin.php',   	'sp_watches_deactivate');
add_action('sph_uninstall_watches/sp-watches-plugin.php',     	'sp_watches_uninstall');
add_action('init', 										    	'sp_watches_localization');
add_action('sph_print_plugin_scripts', 							'sp_watches_load_js');
add_action('sph_ahah_handler_watches-manage', 			    	'sp_watches_ahah_manage');
add_action('sph_ahah_handler_watches-topics', 			    	'sp_watches_ahah_topics');
add_action('sph_ahah_handler_watches-users', 			    	'sp_watches_ahah_users');
add_action('sph_print_plugin_styles', 							'sp_watches_header');
add_action('sph_scripts_admin_end', 					       	'sp_watches_load_admin_js');
add_action('sph_admin_menu', 							    	'sp_watches_menu');
add_action('sph_setup_forum', 							    	'sp_watches_process_actions');
add_action('sph_topic_delete', 							    	'sp_watches_topic_delete');
add_action('sph_member_created', 						    	'sp_watches_member_add');
add_action('sph_member_deleted', 						    	'sp_watches_member_del');
add_action('sph_new_forum_post', 						    	'sp_watches_new_forum_post', 1);
add_action('sph_quickreply_form',                   	    	'sp_watches_admin_bar', 10, 3);
add_action('sph_quick_reply',                       	        'sp_watches_quick_reply');
add_action('sph_toolbox_housekeeping_profile_tabs',             'sp_watches_reset_profile_tabs');
add_action('admin_footer',                                      'sp_watches_upgrade_check');
add_action('sph_plugin_update_watches/sp-watches-plugin.php',   'sp_watches_upgrade_check');
add_action('sph_permissions_reset',                             'sp_watches_reset_permissions');
add_action('sph_get_query_vars', 							                'sp_watches_get_query_vars');
add_action('sph_get_def_query_vars', 						                'sp_watches_get_def_query_vars');

add_filter('sph_perms_tooltips', 				    'sp_watches_tooltips', 10, 2);
add_filter('sph_admin_help-admin-users', 		    'sp_watches_admin_help', 10, 3);
add_filter('sph_plugins_active_buttons', 		    'sp_watches_uninstall_option', 10, 2);
add_filter('sph_memberdata_update_query', 		    'sp_watches_member_update', 10, 4);
add_filter('sph_post_message', 					    'sp_watches_post_create', 10, 2);
add_filter('sph_TopicIndexStatusIconsLast', 	    'sp_watches_forum_status', 10, 2);
add_filter('sph_post_options_add', 				    'sp_watches_post_form_options', 10, 2);
add_filter('sph_topic_options_add', 			    'sp_watches_topic_form_options', 10, 2);
add_filter('sph_forumview_query', 				    'sp_watches_forum_query');
add_filter('sph_forumview_topic_records', 		    'sp_watches_records', 10, 2);
add_filter('sph_topicview_query', 				    'sp_watches_forum_query');
add_filter('sph_topicview_topic_record', 		    'sp_watches_records', 10, 2);
add_filter('sph_add_post_tool', 	           	    'sp_watches_post_tool', 10, 9);
add_filter('sph_add_topic_tool', 		            'sp_watches_topic_tool', 10, 4);
add_filter('sph_post_editor_footer_bottom', 	    'sp_watches_post_footer', 10, 3);
add_filter('sph_post_editor_display_options', 	    'sp_watches_editor_options');
add_filter('sph_topic_editor_display_options', 	    'sp_watches_editor_options');
add_filter('sph_load_admin_textdomain', 		    'sp_watches_load_admin');
add_filter('sph_ProfileFormSave_manage-watches',    'sp_watches_profile_update', 10, 3);
add_filter('sph_rewrite_rules_start', 			    'sp_watches_rewrite_rules', 10, 3);
add_filter('sph_query_vars', 					    'sp_watches_query_vars');
add_filter('sph_pageview', 						    'sp_watches_pageview');
add_filter('sph_canonical_url', 				    'sp_watches_canonical_url');
add_filter('sph_page_title', 					    'sp_watches_page_title', 10, 2);
add_filter('sph_BreadCrumbs', 				        'sp_watches_breadcrumb', 10, 5);
add_filter('sph_BreadCrumbsMobile', 		        'sp_watches_breadcrumbMobile', 10, 2);
add_filter('sph_DefaultViewTemplate',			    'sp_watches_template_name', 10, 2);

function sp_watches_menu() {
        $subpanels = array(
                __('Watches (by Topic)', 'sp-watches') => array('admin' => 'sp_watches_admin_topics', 'save' => '', 'form' => 0, 'id' => 'watchtopic'),
                __('Watches (by User)', 'sp-watches') => array('admin' => 'sp_watches_admin_users', 'save' => '', 'form' => 0, 'id' => 'watchuser')
        );
        sp_add_admin_subpanel('users', $subpanels);
}

function sp_watches_admin_topics() {
    include_once(WADMINDIR.'sp-watches-admin-topics.php');
	sp_watches_admin_topics_form();
}

function sp_watches_admin_users() {
    include_once(WADMINDIR.'sp-watches-admin-users.php');
	sp_watches_admin_users_form();
}

function sp_watches_admin_help($file, $tag, $lang) {
    if ($tag == '[topic-watches]' || $tag == '[watches-topics]' || $tag == '[watches-users]') $file = WADMINDIR.'sp-watches-admin-help.'.$lang;
    return $file;
}

function sp_watches_uninstall_option($actionlink, $plugin) {
    include_once(WLIBDIR.'sp-watches-components.php');
    $actionlink = sp_watches_uninstall_option_links($actionlink, $plugin);
	return $actionlink;
}

function sp_watches_localization() {
	sp_plugin_localisation('sp-watches');
}

function sp_watches_tooltips($tips, $t) {
    $tips['watch'] = $t.__('Can set a watch on any topic in the forum', 'sp-watches');
    return $tips;
}

function sp_watches_uninstall() {
    include_once(WDIR.'sp-watches-uninstall.php');
    sp_watches_do_uninstall();
}

function sp_watches_install() {
    include_once(WDIR.'sp-watches-install.php');
    sp_watches_do_install();
}

function sp_watches_deactivate() {
    include_once(WLIBDIR.'sp-watches-components.php');
    sp_watches_do_deactivate();
}

function sp_watches_reset_permissions() {
    include_once(WDIR.'sp-watches-install.php');
    sp_watches_do_reset_permissions();
}

function sp_watches_ahah_manage() {
    include_once(WLIBDIR.'sp-watches-components.php');
    include_once(WAHAHDIR.'sp-watches-ahah-manage.php');
}

function sp_watches_ahah_topics() {
    include_once(WAHAHDIR.'sp-watches-ahah-topics.php');
}

function sp_watches_ahah_users() {
    include_once(WAHAHDIR.'sp-watches-ahah-users.php');
}

function sp_watches_load_admin_js($footer) {
    $script = (defined('SP_SCRIPTS_DEBUG') && SP_SCRIPTS_DEBUG) ? WSCRIPT.'sp-watches-admin-dev.js' : WSCRIPT.'sp-watches-admin.js';
	wp_enqueue_script('sp-watches-admin', $script, false, false, $footer);
}

function sp_watches_header() {
    include_once(WLIBDIR.'sp-watches-components.php');
    sp_watches_do_header();
}

function sp_watches_load_js($footer) {
    include_once(WLIBDIR.'sp-watches-components.php');
	sp_watches_do_load_js($footer);
}

function sp_watches_process_actions() {
    include_once(WLIBDIR.'sp-watches-components.php');
	sp_watches_do_process_actions();
}

function sp_watches_topic_delete($posts) {
    include_once(WLIBDIR.'sp-watches-components.php');
	sp_watches_do_topic_delete($posts);
}

function sp_watches_member_add($userid) {
    include_once(WLIBDIR.'sp-watches-database.php');
	sp_watches_do_member_add($userid);
}

function sp_watches_member_del($userid) {
    include_once(WLIBDIR.'sp-watches-database.php');
	sp_watches_do_member_del($userid);
}

function sp_watches_post_create($msg, $newpost) {
    include_once(WLIBDIR.'sp-watches-components.php');
	$msg = sp_watches_do_post_create($msg, $newpost);
	return $msg;
}

function sp_watches_member_update($sql, $itemname, $itemdata, $userid) {
	if ($itemname == 'watches') $sql = "UPDATE ".SFMEMBERS." SET watches = ".$itemdata." WHERE user_id=".$userid;
	return $sql;
}

function sp_watches_new_forum_post($newpost) {
	if (isset($_POST['topicwatch'])) $newpost['topicwatch'] = sp_esc_str($_POST['topicwatch']);
	if (isset($_POST['topicwatchend'])) $newpost['topicwatchend'] = sp_esc_str($_POST['topicwatchend']);
	return $newpost;
}

function sp_watches_forum_status($content) {
    include_once(WLIBDIR.'sp-watches-components.php');
	$content = sp_watches_do_forum_status($content);
	return $content;
}

function sp_watches_topic_form_options($content, $thisForum) {
    include_once(WLIBDIR.'sp-watches-components.php');
	$content = sp_watches_do_topic_form_options($content, $thisForum);
	return $content;
}

function sp_watches_post_form_options($content, $thisTopic) {
    include_once(WLIBDIR.'sp-watches-components.php');
	$content = sp_watches_do_post_form_options($content, $thisTopic);
	return $content;
}

function sp_watches_forum_query($query) {
	$query->fields.= ', topic_watches';
	return $query;
}

function sp_watches_records($data, $record) {
	$data->topic_watches = $record->topic_watches;
	return $data;
}

function sp_watches_admin_bar($newtopic, $topic, $post) {
    include_once(WLIBDIR.'sp-watches-components.php');
	sp_watches_do_admin_bar($newtopic, $topic, $post);
}

function sp_watches_quick_reply($newpost) {
    include_once(WLIBDIR.'sp-watches-database.php');
    include_once(WLIBDIR.'sp-watches-components.php');
	sp_watches_do_quick_reply($newpost);
}

function sp_watches_topic_tool($out, $topic, $forum, $page) {
    include_once(WLIBDIR.'sp-watches-components.php');
	$out = sp_watches_forum_tool($out, $forum, $topic);
    return $out;
}

function sp_watches_post_tool($out, $post, $forum, $topic, $page, $postnum, $useremail, $guestemail, $displayname) {
    include_once(WLIBDIR.'sp-watches-components.php');
	$out = sp_watches_forum_tool($out, $forum, $topic);
    return $out;
}

function sp_watches_post_footer($out, $spThisTopic, $a) {
    include_once(WLIBDIR.'sp-watches-components.php');
	$out = sp_watches_do_post_footer($out, $spThisTopic, $a);
	return $out;
}

function sp_watches_editor_options($display) {
	if (sp_get_auth('watch')) $display['options'] = true;
    return $display;
}

function sp_watches_load_admin($special) {
    $special[] = 'sp_ahah=watches-topics';
    return $special;
}

function sp_watches_reset_profile_tabs() {
    include_once(WLIBDIR.'sp-watches-components.php');
    sp_watches_do_reset_profile_tabs();
}

function sp_watches_upgrade_check() {
    include_once(WDIR.'sp-watches-upgrade.php');
    sp_watches_do_upgrade_check();
}

function sp_watches_profile_update($message, $thisUser, $thisForm) {
    include_once(WLIBDIR.'sp-watches-database.php');
    include_once(WLIBDIR.'sp-watches-components.php');
	$message = sp_watches_do_profile_update($message, $thisUser, $thisForm);
	return $message;
}

function sp_watches_rewrite_rules($rules, $slugmatch, $slug) {
	$rules[$slugmatch.'/watches/?$'] = 'index.php?pagename='.$slug.'&sf_watches=view';
    return $rules;
}

function sp_watches_query_vars($vars) {
	$vars[] = 'sf_watches';
    return $vars;
}

function sp_watches_get_query_vars() {
    global $spVars;
	$spVars['watches'] = sp_esc_str(get_query_var('sf_watches'));
	if (empty($spVars['watches'])) $spVars['watches'] = 0;
}

function sp_watches_get_def_query_vars($stuff) {
    global $spVars;
    if ($stuff[1] == 'watches') {
        $spVars['watches'] = true;
        $spVars['plugin-vars'] = true;
    }
	if (empty($spVars['watches'])) $spVars['watches'] = 0;
}

function sp_watches_pageview($pageview) {
    global $spVars;
    if (!empty($spVars['watches'])) $pageview = 'watches';
    return $pageview;
}

function sp_watches_canonical_url($url) {
    global $spVars;
    if ($spVars['pageview'] == 'watches') $url = sp_url("watches");
    return $url;
}

function sp_watches_breadcrumb($breadCrumbs, $args, $crumbEnd, $crumbSpace, $treeCount) {
    global $spVars;
    if (!empty($spVars['watches'])) {
    	extract($args, EXTR_SKIP);
    	if (!empty($icon)) $icon = "<img src='".SPTHEMEICONSURL.sanitize_file_name($icon)."' class='$iconClass' alt=''/>";
		$breadCrumbs.= $crumbEnd.str_repeat($crumbSpace, $treeCount)."<a class='$linkClass' href='".sp_url('watches')."'>".$icon.__('Watches', 'sp-watches').'</a>';
    }
    return $breadCrumbs;
}

function sp_watches_breadcrumbMobile($breadCrumbs, $args) {
    global $spVars;
    if (!empty($spVars['watches'])) {
    	extract($args, EXTR_SKIP);
		$breadCrumbs.= "<a class='$tagClass' href='".sp_url('watches')."'>".$icon.__('Watches', 'sp-watches').'</a>';
    }
    return $breadCrumbs;
}

function sp_watches_page_title($title, $sep) {
    global $spVars;
	$sfseo = sp_get_option('sfseo');
	if ($sfseo['sfseo_page'] && $spVars['pageview'] == 'watches') $title = __('Watches', 'sp-watches').$sep.$title;
    return $title;
}

function sp_watches_template_name($name, $pageview) {
	if ($pageview != 'watches') return $name;
	$tempName = sp_find_template(WTEMPDIR,'spWatchesView.php');
	return $tempName;
}

# Define Template Tags globally available (dont have to be enabled on template tag panel)

function sp_WatchesReviewButton($args='', $label='', $toolTip='') {
    include_once(WTAGSDIR.'sp-watches-review-button-tag.php');
    sp_WatchesReviewButtonTag($args, $label, $toolTip);
}

function sp_WatchesWatchButton($args='', $watchLabel='', $stopWatchLabel='', $watchToolTip='', $stopWatchToolTip='') {
    include_once(WTAGSDIR.'sp-watches-watch-button-tag.php');
    sp_WatchesWatchButtonTag($args, $watchLabel, $stopWatchLabel, $watchToolTip, $stopWatchToolTip);
}

function sp_WatchesUnreadTopics($display=true) {
    include_once(WTAGSDIR.'sp-watches-topics-tag.php');
	sp_WatchesUnreadTopicsTag($display=true);
}
?>