<?php
/*
$LastChangedDate: 2013-08-23 12:55:44 -0700 (Fri, 23 Aug 2013) $
$Rev: 10569 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_WatchesReviewButtonTag($args='', $label='', $toolTip='') {
	global $spVars, $spThisUser;

	sp_forum_api_support();

	if (!sp_get_auth('watch', $spVars['forumid'])) return;

	$defs = array('tagId'      	=> 'spWatchesReviewButton',
                  'tagClass' 	=> 'spWatchesReviewButton',
				  'labelClass'	=> 'spInRowLabel',
				  'iconClass'	=> 'spIcon',
				  'icon'		=> 'sp_WatchesReviewButton.png',
                  'first'       => 0,
				  'popup'		=> 1,
				  'linkId'      => 'spWatchesLink',
				  'mobileMenu'	=> 0,
				  );
	$a = wp_parse_args($args, $defs);
	$a = apply_filters('sph_WatchesReviewButton_args', $a);
	extract($a, EXTR_SKIP);

	# sanitize before use
	$tagId 		    = esc_attr($tagId);
	$tagClass		= esc_attr($tagClass);
	$labelClass		= esc_attr($labelClass);
	$iconClass		= esc_attr($iconClass);
	$icon			= sp_find_icon(WIMAGES, sanitize_file_name($icon));
	$first   	    = (int) $first;
	$popup   	    = (int) $popup;
	$linkId     	= esc_attr($linkId);
	$mobileMenu		= (int) $mobileMenu;
	$label			= sp_filter_title_display($label);
	$toolTip		= esc_attr($toolTip);

	$watchCount = 0;
	$list = $spThisUser->watches;
	if (!empty($list)) {
		foreach ($list as $topicid) {
			if (sp_is_in_users_newposts($topicid)) $watchCount++;
		}
	}

    $out = '';
	if ($mobileMenu) {
    	$label = str_ireplace('%COUNT%', $watchCount, $label);
		$out.= "<li class='$tagClass' id='$tagId'><a rel='nofollow' id='$linkId' href='".sp_get_sfqurl(sp_url('watches'))."first=$first"."'>$label</a></li>\n";
	} else {
        if ($popup) {
        	$site = SFHOMEURL.'index.php?sp_ahah=watches-manage&amp;sfnonce='.wp_create_nonce('forum-ahah')."&amp;action=watch&amp;first=$first";
        	$out = "<a rel='nofollow' id='$tagId' class='$tagClass vtip' title='$toolTip' href='javascript:void(null)' onclick='spjDialogAjax(this, \"$site\", \"$toolTip\", 700, 500, \"center\");' >";
        } else {
			$out.= "<a rel='nofollow' id='$tagId' class='$tagClass vtip' title='$toolTip' href='".sp_get_sfqurl(sp_url('watches'))."first=$first"."'>";
        }
    	if (!empty($icon)) $out.= "<img class='$iconClass' src='".$icon."' alt='' />";
        $watchClass = ($watchCount > 0) ? 'spWatchCountUnread' : 'spWatchCountRead';
    	$out.= "$label  <span id='spWatchCount'><span class='$watchClass'>$watchCount</span></span>";
    	$out.= "</a>\n";
    }

	$out = apply_filters('sph_WatchesReviewButton', $out, $a);
	echo $out;
}

?>