<?php
/*
$LastChangedDate: 2013-04-18 22:21:03 -0700 (Thu, 18 Apr 2013) $
$Rev: 10187 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

/* 	=====================================================================================
	sp_WatchesUnreadTopicsTag($display)

	template tag to display number of unread watched topics.  This tag includes
	default text that is output with the unread count data.   This text can
	be suppressed by setting $display to false. If suppressed, the new unread count is returned
    to the caller. Nothing is displayed and 0 returned for guests.

	parameters:

		$display		Determines whether to display unread count plus informational text
 	===================================================================================*/
function sp_WatchesUnreadTopicsTag($display=true) {
    #check if forum displayed
    if (sp_abort_display_forum()) return;

	global $spThisUser;

	sp_forum_api_support();

	$count = 0;
	if ($spThisUser->member) {
		$list = $spThisUser->watches;
		if (!empty($list)) {
			$newpostlist = $spThisUser->newposts;
			if(empty($newpostlist)) sp_update_users_newposts(true);
			foreach ($list as $topicid) {
				if (sp_is_in_users_newposts($topicid)) $count++;
			}
		}
	}

	if ($display) {
		$out = '';
		if ($spThisUser->member) {
			$out .= '<p class="spWatched">';
			$out .= __('You have', 'sp-watches').' '.$count.' '.__('unread watched topics', 'sp-watches').'.';
			$out .= '</p>';
		}
        echo $out;
	}
	return $count;
}
?>