<?php
/*
$LastChangedDate: 2013-08-23 12:55:44 -0700 (Fri, 23 Aug 2013) $
$Rev: 10569 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

# 5.2 - mobileMenu arg added

function sp_WatchesWatchButtonTag($args='', $watchLabel='', $stopWatchLabel='', $watchToolTip='', $stopWatchToolTip='') {
	global $spVars, $spThisUser, $spThisTopic, $spGlobals;

	sp_forum_api_support();

	if (!$spThisUser->member || !sp_get_auth('watch', $spVars['forumid']) || $spVars['pageview'] != 'topic' || $spGlobals['lockdown']) return;

	$defs = array('tagClass' 		=> 'spWatchesWatchButton',
                  'tagId' 	     	=> 'spWatchesWatchButton',
				  'labelClass'		=> 'spInRowLabel',
				  'iconClass'		=> 'spIcon',
				  'watchIcon'		=> 'sp_WatchesWatchButton.png',
				  'stopWatchIcon'	=> 'sp_WatchesStopWatchButton.png',
				  'mobileMenu'		=> 0
				  );
	$a = wp_parse_args($args, $defs);
	$a = apply_filters('sph_WatchesWatchButton_args', $a);
	extract($a, EXTR_SKIP);

	# sanitize before use
	$tagId			    = esc_attr($tagId);
	$tagClass			= esc_attr($tagClass);
	$labelClass			= esc_attr($labelClass);
	$iconClass			= esc_attr($iconClass);
	$watchIcon			= sp_find_icon(WIMAGES, sanitize_file_name($watchIcon));
	$stopWatchIcon		= sp_find_icon(WIMAGES, sanitize_file_name($stopWatchIcon));
	$watchLabel			= sp_filter_title_display($watchLabel);
	$stopWatchLabel		= sp_filter_title_display($stopWatchLabel);
	$watchToolTip		= esc_attr($watchToolTip);
	$stopWatchToolTip	= esc_attr($stopWatchToolTip);
	$mobileMenu			= (int) $mobileMenu;

	$out = '';
	if (sp_watches_is_watching($spThisUser->ID, $spVars['topicid'])) {
		$url = add_query_arg(array('forum'=>$spVars['forumid'], 'topic'=>$spVars['topicid'],'endwatch'=>'user', 'forumslug'=>$spVars['forumslug'], 'topicslug'=>$spVars['topicslug'], 'page'=>$spVars['page'], 'post'=>$spThisTopic->last_post_id), sp_url());
		if(!$mobileMenu) {
			$out.= "<a rel='nofollow' id='$tagId' class='$tagClass vtip' title='$stopWatchToolTip' href='$url' >";
			if (!empty($stopWatchIcon)) $out.= "<img class='$iconClass' src='".$stopWatchIcon."' alt='' />";
			$out.= $stopWatchLabel."</a>\n";
		} else {
			$out.= "<li><a rel='nofollow' href='$url'>$stopWatchLabel</li></a>\n";
		}
	} else {
		$url = add_query_arg(array('forum'=>$spVars['forumid'], 'topic'=>$spVars['topicid'],'watch'=>'user', 'forumslug'=>$spVars['forumslug'], 'topicslug'=>$spVars['topicslug'], 'page'=>$spVars['page'], 'post'=>$spThisTopic->last_post_id), sp_url());
		if(!$mobileMenu) {
			$out.= "<a rel='nofollow' id='$tagId' class='$tagClass vtip' title='$watchToolTip' href='$url' >";
			if (!empty($watchIcon)) $out.= "<img class='$iconClass' src='".$watchIcon."' alt='' />";
			$out.= $watchLabel."</a>\n";
		} else {
			$out.= "<li><a rel='nofollow' href='$url'>$watchLabel</li></a>\n";
		}
	}

	$out = apply_filters('sph_WatchesWatch', $out, $a);
	echo $out;
}

?>